'******************************************************************** 
'                            DICE.BAS
'              for Flash Of Inspiration I  18.06.2004
'                            WUERFEL.BAS 
'                            05.08.1999 
' 
'(c)Ing.Buero Lehmann, Fuerstenbergstr. 8a, 77756 Hausach, (07831) 452 
'   Tel. +49 (0)7831 452     Fax +49 (0)7831 96428    www.iL-online.de
'********************************************************************
'        settings and connections
'
'        switches "Tasten PortB" off
'        switches "LCD an PortB" off
'        S1 to PortA,0
'        LD2 to PortA,1

         define device 16f628
         config ircp_osc
         config wdt_off
         config cmcfg7
         config mclr_int
 
         xtal 4.00 

         define key=ra,0               'RA,0 is our key to roll the dice
         define value=$20              'internal value of the dice
         define led=$21                'led equivalent of value


cold: 
         goto start                    'skip subroutines

init: 
         tris rb,%10000000             'RB7=Inp. Rest=Output 
         tris ra,%11111101
         set ra,1                      'right digit on
         return 

disp: 
         if value=1 then let led=%00000110 
         if value=2 then let led=%01011011 
         if value=3 then let led=%01001111 
         if value=4 then let led=%01100110 
         if value=5 then let led=%01101101 
         if value=6 then let led=%01111101 
         output rb,led                 'display it 
         return 

start: 
         gosub init 
         let value=1                   ' init value of the dice 
loop: 
         gosub disp                    'refresh disply 
         if key=1 then goto loop       'wait until key pressed 
count: 
         gosub disp                    'all segments are turned on 
         inc value                     'counting very fast
         if value=7 then let value=1   'if limit then set to 1 
         if key=0 then goto count      'until key is released
         goto loop 



