'****************************************************************************
'                            Vor- und Rckwrtszhler
'                                F_R_Counter.BAS
'
'                               Stand: 24.06.2009
'
'                                  3. Schritt 
'
'(c) Ing.Bro Lehmann, Frstenbergstrae 8a, 77756 Hausach, www.iL-online.de
'****************************************************************************

'Historie
'Schritt3: nun soll das Segment blinken
'Schritt2: weil mehr wie ein Segment leuchten, werden die brigen explizit 
'          abgeschaltet.

'Besonderheiten
'Auf der PICUP-Platine mssen die Steckbrcken (Jumper) wie folgt gesteckt sein:
'JP1A und JP1B  jeweils 2-3   -> externer Oszillator (Quarz)
'JP2A und JP2B  jeweils 2-3   -> T3 an RA1  und T2 an RA2

'die beiden nachfolgenden Schalter sind notwendig, wenn das PicKit2 als
'Programmiergert verwendet wird.
         $LIST  /M_OBJ
         $LIST  OBJ2HEX

'hier wird der Prozessortyp und dessen Spezifikationen definiert
         DEFINE DEVICE 16F628A
         CONFIG CMCFG7
         CONFIG HS_OSC
         CONFIG MCLR_INT
         
         XTAL   4.096
         
'hier folgen die Variablendeklarationen (8, 16 und ggf. 32 Bit)         


'hier werden die Bitvariablen definiert


'hier werden die Konstanten definiert

'-------------------------------------------
'ab hier wird Code fr den Prozessor erzeugt
'-------------------------------------------
'falls Unterprogramme verwendet werden, werden diese zuerst bersprungen

cold:
         GOTO      start
         
'hier stehen ggf. die Unterprogramme


'hier beginnt das Hauptprogramm
start:
         LOW       RA,1                '?. Digit (T?) ausschalten
         LOW       RA,2                '?. Digit (T?) ausschalten
         LOW       RA,4                '?. Digit (T?) ausschalten
loop:         
         LOW       RB,6                'Segment A
         HIGH      RA,0                '1. Digit (T4) einschalten
         WAIT      500                 'Segment bleibt 500 ms ein
         LOW       RA,0                '1. Digit (T4) ausschalten
         WAIT      500                 'die Ausphase ist auch 500 ms lang
         GOTO      LOOP                'das Ganze luft nun endlos

         END
         
